//
#include <SPI.h>
#include <Ethernet2.h>
//
#include "LanConfiguration.h"
#include "PowerSwitch.h"
//
const int PIN_RELAYA = 2;
const int PIN_RELAYB = 4;
const int PIN_RELAYC = 26;
const int PIN_RELAYD = 25;
const int PIN_RELAYE = 17;
const int PIN_RELAYF = 16;
const int PIN_RELAYG = 27;
const int PIN_RELAYH = 14;
//
EthernetServer Esp32Server(IPPORT_HTTP);
int HttpRequestCounter = 0;
String HtmlHeader = "";
//
CPowerSwitch RelayA(PIN_RELAYA);
CPowerSwitch RelayB(PIN_RELAYB);
CPowerSwitch RelayC(PIN_RELAYC);
CPowerSwitch RelayD(PIN_RELAYD);
CPowerSwitch RelayE(PIN_RELAYE);
CPowerSwitch RelayF(PIN_RELAYF);
CPowerSwitch RelayG(PIN_RELAYG);
CPowerSwitch RelayH(PIN_RELAYH);
//
void setup() 
{
  Serial.begin(115200);
  delay(333);
  Serial.println("\r\n");
  Serial.println("***********************");
  Serial.println("* Esp32LanPowerSwitch *");
  Serial.println("* Version: 01V03      *");
  Serial.println("* Date...: 211012     *");
  Serial.println("* Time...: 2058       *");
  Serial.println("* Author.: OMdevelop  *");
  Serial.println("***********************");
  //
  RelayA.Open();
  RelayB.Open();
  RelayC.Open();
  RelayD.Open();
  RelayE.Open();
  RelayF.Open();
  RelayG.Open();
  RelayH.Open();
  for (int RI = 0; RI < 10; RI++)
  {
    RelayA.SwitchOn();
//    RelayB.SwitchOn();
//    RelayC.SwitchOn();
//    RelayD.SwitchOn();
//    RelayE.SwitchOn();
//    RelayF.SwitchOn();
//    RelayG.SwitchOn();
//    RelayH.SwitchOn();
    delay(100);
    RelayA.SwitchOff();
//    RelayB.SwitchOff();
//    RelayC.SwitchOff();
//    RelayD.SwitchOff();
//    RelayE.SwitchOff();
//    RelayF.SwitchOff();
//    RelayG.SwitchOff();
//    RelayH.SwitchOff();
    delay(100);
  }
  //
  Serial.println("Init Lan-Connection...");
  Ethernet.init(PIN_SPI_CSS);  
  Ethernet.begin(MAC_ESP32W5500, 
                 IPADDRESS_DEVICE); 
//                 IPADDRESS_DNS,    
//                 IPADDRESS_GTW,    
//                 IPADDRESS_SNM);   
  Esp32Server.begin(IPPORT_HTTP);
  Serial.print("Connected to IPAddress[");
  Serial.print(Ethernet.localIP());
  Serial.println("]");
  //
  delay(200);
}

void loop() 
{
  delay(1000);
  // listen for incoming clients
  EthernetClient Esp32Client = Esp32Server.available();
  if (Esp32Client) 
  { // debug Serial.println("Http-Request from Client detected");
    // Http-Request ends with a blank line!
    boolean CurrentLineIsBlank = true;
    while (Esp32Client.connected()) 
    {
      if (Esp32Client.available()) 
      {
        char C = Esp32Client.read();
        // PROTOCOL !!!! Serial.write(C);
        HtmlHeader += C;
        // if you've gotten to the end of the line (received a newline
        // character) and the line is blank, the http request has ended,
        // so you can send a reply
        if (('\n' == C) && CurrentLineIsBlank) 
        { 
          HttpRequestCounter++;
          //-----------------------------------------------------------          
          // Analyse HttpRequest-Parameters:
          //-----------------------------------------------------------
          //       Relay A       
          if (0 <= HtmlHeader.indexOf("GET /RA0"))
          {
            HtmlHeader = "";
            Serial.println("Parameter[/RA0]: RelayA OFF");
            RelayA.SwitchOff();
          }
          else
          if (0 <= HtmlHeader.indexOf("GET /RA1")) 
          {
            HtmlHeader = "";
            Serial.println("Parameter[/RA1]: RelayA ON");
            RelayA.SwitchOn();
          }
          else // Relay B
          if (0 <= HtmlHeader.indexOf("GET /RB0"))
          {
            HtmlHeader = "";
            Serial.println("Parameter[/RB0]: RelayB OFF");
            RelayB.SwitchOff();
          }
          else
          if (0 <= HtmlHeader.indexOf("GET /RB1")) 
          {
            HtmlHeader = "";
            Serial.println("Parameter[/RB1]: RelayB ON");
            RelayB.SwitchOn();
          }
          else // Relay C
          if (0 <= HtmlHeader.indexOf("GET /RC0"))
          {
            HtmlHeader = "";
            Serial.println("Parameter[/RC0]: RelayC OFF");
            RelayC.SwitchOff();
          }
          else
          if (0 <= HtmlHeader.indexOf("GET /RC1")) 
          {
            HtmlHeader = "";
            Serial.println("Parameter[/RC1]: RelayC ON");
            RelayC.SwitchOn();
          }
          else // Relay D
          if (0 <= HtmlHeader.indexOf("GET /RD0"))
          {
            HtmlHeader = "";
            Serial.println("Parameter[/RD0]: RelayD OFF");
            RelayD.SwitchOff();
          }
          else
          if (0 <= HtmlHeader.indexOf("GET /RD1")) 
          {
            HtmlHeader = "";
            Serial.println("Parameter[/RD1]: RelayD ON");
            RelayD.SwitchOn();
          }
          else // Relay E
          if (0 <= HtmlHeader.indexOf("GET /RE0"))
          {
            HtmlHeader = "";
            Serial.println("Parameter[/RE0]: RelayE OFF");
            RelayE.SwitchOff();
          }
          else
          if (0 <= HtmlHeader.indexOf("GET /RE1")) 
          {
            HtmlHeader = "";
            Serial.println("Parameter[/RE1]: RelayE ON");
            RelayE.SwitchOn();
          }
          else // Relay F
          if (0 <= HtmlHeader.indexOf("GET /RF0"))
          {
            HtmlHeader = "";
            Serial.println("Parameter[/RF0]: RelayF OFF");
            RelayF.SwitchOff();
          }
          else
          if (0 <= HtmlHeader.indexOf("GET /RF1")) 
          {
            HtmlHeader = "";
            Serial.println("Parameter[/RF1]: RelayF ON");
            RelayF.SwitchOn();
          }
          else // Relay G
          if (0 <= HtmlHeader.indexOf("GET /RG0"))
          {
            HtmlHeader = "";
            Serial.println("Parameter[/RG0]: Relay OFF");
            RelayG.SwitchOff();
          }
          else
          if (0 <= HtmlHeader.indexOf("GET /RG1")) 
          {
            HtmlHeader = "";
            Serial.println("Parameter[/RG1]: RelayG ON");
            RelayG.SwitchOn();
          }
          else // Relay H
          if (0 <= HtmlHeader.indexOf("GET /RH0"))
          {
            HtmlHeader = "";
            Serial.println("Parameter[/RH0]: RelayH OFF");
            RelayH.SwitchOff();
          }
          else
          if (0 <= HtmlHeader.indexOf("GET /RH1")) 
          {
            HtmlHeader = "";
            Serial.println("Parameter[/RH1]: RelayH ON");
            RelayH.SwitchOn();
          }
          else
          {
//            Serial.print("Invalid Parameter detected: <");;
//            Serial.print(HtmlHeader);;
//            Serial.println(">");;
            HtmlHeader = "";
          }
          //-----------------------------------------------------------          
          // Send a standard HttpResponseHeader back to Clients Request
          //-----------------------------------------------------------          
          Esp32Client.println("HTTP/1.1 200 OK");
          Esp32Client.println("Content-Type: text/html");
          Esp32Client.println("Connection: close");  // the connection will be closed after completion of the response
          Esp32Client.print("Refresh: ");
          Esp32Client.println(TIME_AUTOREFRESH);
          Esp32Client.println("");
          Esp32Client.println("<!DOCTYPE HTML>");
          Esp32Client.println("<html>");
          // WebSite-Header
          Esp32Client.println("<h2>Esp32LanPowerSwitch</h2>");
          // HttpRequestCounter
          Esp32Client.print("<br>HttpRequestCounter[1]: ");
          Esp32Client.print(HttpRequestCounter);
          Esp32Client.println("<br />");
          // LocalDeviceTime
          Esp32Client.print("<br />LocalDeviceTime[ms]: ");
          Esp32Client.print(millis());
          Esp32Client.println("<br />");
          // AdcValues
          Esp32Client.println("<br />ADCValues:<br />");
          for (int AnalogChannel = 0; AnalogChannel < 6; AnalogChannel++) 
          {
            int SensorReading = random(0, 4096); //analogRead(AnalogChannel);
            Esp32Client.print("AnalogInput[");
            Esp32Client.print(AnalogChannel);
            Esp32Client.print("]: ");
            Esp32Client.print(SensorReading);
            Esp32Client.println("<br />");
          }
          // RelayList
          Esp32Client.println("<br />RelayList:<br />");
          Esp32Client.print("RelayA["); Esp32Client.print(RelayA.GetState()); Esp32Client.println("]<br />");
          Esp32Client.print("RelayB["); Esp32Client.print(RelayB.GetState()); Esp32Client.println("]<br />");
          Esp32Client.print("RelayC["); Esp32Client.print(RelayC.GetState()); Esp32Client.println("]<br />");
          Esp32Client.print("RelayD["); Esp32Client.print(RelayD.GetState()); Esp32Client.println("]<br />");
          Esp32Client.print("RelayE["); Esp32Client.print(RelayE.GetState()); Esp32Client.println("]<br />");
          Esp32Client.print("RelayF["); Esp32Client.print(RelayF.GetState()); Esp32Client.println("]<br />");
          Esp32Client.print("RelayG["); Esp32Client.print(RelayG.GetState()); Esp32Client.println("]<br />");
          Esp32Client.print("RelayH["); Esp32Client.print(RelayH.GetState()); Esp32Client.println("]<br />");          
          //
          Esp32Client.println("</html>");
          break;
        }
        if ('\n' == C) 
        { // you're starting a new line
          CurrentLineIsBlank = true;
        }
        else 
        if ('\r' != C) 
        { // you've gotten a character on the current line
          CurrentLineIsBlank = false;
        }
      }
    }
    // give the web browser time to receive the data
    delay(1);
    // close the connection:
    Esp32Client.stop();
    // debug Serial.println("Esp32Client disconnected");
  }
}
